	
#include "proFit_definitions.h"

// utility function to set the strings supplied by proFit to pascal type strings
// i.e., with the first char containing the length and no zero-termination, as in C

void CopyToPascalStr(char* s1,Str255 s2, short limit)
{	short i = 0;
	unsigned char* olds2 = s2;
	s2 += 1;
	while ((*(s2++)=*(s1++)) && (i<limit)) i += 1;
	olds2[0] = i;
}



/***** implementation of the functions that use the record runTimeParamRec *****/

void newCurve (double thick,short dash, short color,char* name, infoPtrT iP)
	{	runTimeParamRec pb;
		Str255 s;
			
		pb.u.s1.thick = thick;
		pb.u.s1.dash = dash;
		pb.u.s1.color = color;
		pb.what = 1;
		CopyToPascalStr(name,s,255);
		pb.u.s1.curveName = s;
		iP->rtProc(&pb);
	}

void grMoveto (double x, double y, infoPtrT iP)
	{	runTimeParamRec pb;
		pb.u.s2.x = x;
		pb.u.s2.y = y;
		pb.what = 2;
		iP->rtProc(&pb);
	}

void grLineto (double x, double y, infoPtrT iP)
	{	runTimeParamRec pb;
		pb.u.s3.x = x;
		pb.u.s3.y = y;
		pb.what = 3;
		iP->rtProc(&pb);
	}

void getGrafCoordinates (double* xmin, double* xmax, double* ymin, double* ymax,infoPtrT iP)
	{	runTimeParamRec pb;
		pb.u.s4.xmin = xmin;
		pb.u.s4.xmax = xmax;
		pb.u.s4.ymin = ymin;
		pb.u.s4.ymax = ymax;
		pb.what = 4;
		iP->rtProc(&pb);
	}
	
double pRandom (infoPtrT iP)
	{	runTimeParamRec pb;
		pb.what=11;
		iP->rtProc(&pb);
		return pb.u.retVal;
	}

short xColumn (infoPtrT iP)
	{	runTimeParamRec pb;
		pb.what=20;
		iP->rtProc(&pb);
		return pb.u.retVal;
	}

short yColumn (infoPtrT iP)
	{	runTimeParamRec pb;
		pb.what=21;
		iP->rtProc(&pb);
		return pb.u.retVal;
	}


short xErrColumn (infoPtrT iP)
	{	runTimeParamRec pb;
		pb.what=22;
		iP->rtProc(&pb);
		return pb.u.retVal;
	}


short yErrColumn (infoPtrT iP)
	{	runTimeParamRec pb;
		pb.what=23;
		iP->rtProc(&pb);
		return pb.u.retVal;
	}

