unit code;

{This is an example of a pascal definition of a data transformation algorithm						}
{ that will be installed in proFit's function menu.														}
{This pascal source can be compiled by many pascal compilers for the macintosh with only minor}
{changes.}
{This pascal unit uses another unit, called codeGlobals, that contains all the constants and type definitions}
{needed. If your pascal compiler does not allow the use of separate units you must merge the two files}
{see the proFit user manual for further details}

{ To add this program to proFit's user menu, proceed as follows:									}

{    compile this unit with your compiler  tell your compiler to save it as a CODE resource. 		}
{    (Most current compilers on the Macintosh (MPW, ThinkPascal,  ...) 								}
{    allow to make a code resource  this feature is used for the compilation of device drivers, 	}
{    desk accessories, window definition procedures etc. Find more details in your compiler's 	}
{    manual.) The code resource must have type 'pgrf' or 'pgrn' depending on wether you generate }
{	code for the floating point unit or not ! Its ID is not important. 									}
{    Save this resource and add it to proFit using the External Modules...   commmand.				}

{ IMPORTANT NOTE: }
{ The special way in which global variables are treated in Macintosh compilers makes it 			}
{ impossible to use global variables in spearated code segments. This means that you  			}
{ MUST NOT define any variables outside your procedures! 							 				}

{The example source for the 'ErrorFunction' shows how to use the userglobals record to store   }
{ global variables																					}

interface

	uses
		proFitDefinitions;

{ You MUST use the following declaration of the procedure main EXACTLY as it is given here. 	}
{ ANY change is guaranteed to cause very ugly crashes !!!											}

{ The procedure main is called by proFit the first time the user code is linked. It sets pointers to }
{ all the routines that proFit will use and must do all the initializations that will be needed by 		}
{ routines. proFit does not perform any check on the values set by main. It will crash in a 		}
{ horrible and painful way if you do not do all the initializations properly. See the proFit user 	}
{ manual for more details. 																				}

	procedure main (var name: str20;			{ the name of the function }
									var runPtr: ptr;				{ pointer to the procedure 'run' or nil if not used }
									var freeUserMPtr: ptr; 		{ pointer to the procedure 'freeUserMemory' or nil if not used }
									InfPtr: GlobalsPtrT);			{ pointer to a record containing global variables and some proFit globals available to the user }

implementation

	procedure run (InfPtr: globalsPtrT);
{ this is the routine that does the real work for you ... }
{ In this example it just fills the current data window with a multiplication table }
		var
			i, j: integer;
	begin
		for i := 1 to InfPtr^.proFitInfo^.nrRows do
			for j := 1 to InfPtr^.proFitInfo^.nrCols do
				SetData(j, i, i * j, InfPtr^.proFitInfo^.setDataPtr);
	end;

	procedure main (var name: str20;			{ the name of the function }
									var runPtr: ptr;				{ pointer to the procedure 'run' (must not be nil) }
									var freeUserMPtr: ptr; 		{ pointer to the procedure 'freeUserMemory' or nil if not used }
									InfPtr: globalsPtrT);			{ pointer to a record containing global variables and some proFit globals available to the user }
	begin
		name := 'Multiply';
		runPtr := @Run;
		freeUserMPtr := nil;		{ we didn't make any global data in a handle ! }
	end;  { main }

end.